<template>
  <span :id="id" :name="field.name+'_show'" class="component-input-span">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || (field.textType && field.textType.toLowerCase() == 'hidden')"
    >
      <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->
      <input type="hidden" v-model="field.value" />
      <div class="textarea-cell" v-if="field.mobile&&field.hiddenValue">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
        </div>
        <div class="view-li">
          <div class="view-li-right">
            {{field.hiddenValue}}
          </div>
        </div>
      </div>
    </template>
    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <!-- 可编辑 -->
      <div :class="{textareaWrap: isActive}">
        <div class="textarea-cell" :class="{textareaCheck: isActive }" v-if="field.mobile">
          <div class="titleName">
            {{field.discript?field.discript:field.name}}
            <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
          </div>
          <!-- <mt-field
            class="aa"
            :style="{height: field.textareaHeight?field.textareaHeight + 'px':'80px'}" 
            :placeholder="$t('please_enter')"
            type="textarea" 
            :name="field.name"
            rows="3" 
            v-model="field.value"
            @blur.native.capture="checkData"
            @change="onChange"
          >
          </mt-field> -->
          <a class="mint-cell mint-field" :name="field.name" :style="{height: field.textareaHeight?field.textareaHeight + 'px':'80px'}" >
            <div class="mint-cell-left"></div> 
            <div class="mint-cell-wrapper">
              <div class="mint-cell-value">
                <textarea :placeholder="$t('please_enter')" 
                  rows="3" 
                  class="mint-field-core" 
                  style="color:black"
                  @blur.capture="checkData"
                  @change="onChange"
                  v-model="field.value"
                >
                </textarea>
              </div>
            </div>
          </a>
          <div class="tips" v-show="isActive">
            {{errorMessage}}
          </div>
        </div>
      </div>
    </template>
    <template v-else-if="field.readOnlyShowValOnly">
      <!-- 只读（文本模式） -->
      <div class="textarea-cell" v-if="field.mobile">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
          <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>  
        </div>
        <a class="mint-cell mint-field is-textarea">
          <div class="mint-cell-wrapper"> 
            <div class="mint-cell-value">
              <div class="mint-field-core"><span class="content span_left_down" style="" v-html="field.value"></span></div>
            </div> 
          </div> 
        </a>
      </div>
    </template>
    <template v-else>
      <!-- 只读（控件模式） -->
      <div class="textarea-cell" v-if="field.mobile">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
          <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>  
        </div>
        <!-- <mt-field 
          :style="{height: field.textareaHeight?field.textareaHeight + 'px':'80px' }"
          type="textarea"   
          rows="3"
          :readonly="true"
          :name="field.name"
          v-model="field.value"
          >
        </mt-field> -->
        <a class="mint-cell mint-field is-textarea" :style="{height: field.textareaHeight?field.textareaHeight + 'px':'80px' }">
          <div class="mint-cell-wrapper"> 
            <div class="mint-cell-value">
              <div class="mint-field-core"><span class="content span_left_down" style="" v-html="field.value"></span></div>
            </div> 
          </div> 
        </a>
      </div>
    </template>
  </span>
</template>

<script>
import Constant from "@/Constant.js"
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-textarea",
  props: ["id"],
  computed: {
    field: function() {
      let data = this.$parent.findField(this.id)
      if(data.discript) {
        if(data.discript.charAt(data.discript.length - 1) == "*") {
          data.discript = data.discript.replace(/(\s|\*)+$/g, '');
          data.essential = true;
        }
      }
      if(data.value) {
        // data.value = data.value.replace(/\/n/gm,"\n");
        let val = data.value.replace(/\n/g,'Ent');
        if((data.displayType == 1 && data.readOnlyShowValOnly) || (data.displayType == 4 && data.readOnlyShowValOnly)) {
          data.value = val.replace(/Ent/g,"<br/>");
        }
      }
     
      return this.$parent.findField(this.id);
    }
  },
  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },

  methods: {
    checkData() {
      if(this.field.instantValidate) {
        this.isFieldClear = false;
        let value = true;
        let formData = this.$parent.checkData(value);
        //item[this.field.name] = this.field.value;
        this.$api.formValidation(
          this.$root.appid, 
          formData,
          {
            onSucess: response => {
              if(response.data.errcode == 4001) {
                if(response.data.errors && response.data.errors.length > 0) {
                  let arr = response.data.errors;
                  for(let i=0; i<arr.length; i++) {
                    if(this.field.name == arr[i].field) {
                      this.isActive = true;
                      this.errorMessage = arr[i].errmsg
                      return;
                    }else {
                      this.isActive = false;
                      this.errorMessage = '';
                    }
                  }
                }
              }else if(response.data.errcode == 0) {
                this.isActive = false;
              }
            }
          }
        
        )
      } 
    },
    onChange(){
      if (this.field.refreshOnChanged){
        let havePar = false;
        let par  = '';
        while(!havePar) {
          par = par + '.$parent';
          let url = 'this' + par + '.refresh';
          if(eval(url)) {
            let path = url + '(' + "'"+ this.id +"'" + ')';
            eval(path);
            break
          }
        }
        // this.$parent.refresh(this.id);
      }
    }
  },
  data: function() {
    return { 
      Constant,
      errorMessage:'',
      isActive:false,
    };
  }
};
</script>
